/****************************************************************************
sumj.cpp

Thu 12/30/2010 6:57 pm. creation

===============================================================================
This software is copyrighted under a BSD-style license as follows. Copyright
(c) 2011, James Gregor Owen All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

* Neither the name of the author nor the names of any associates may be used
to endorse or promote products derived from this software without specific
prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

j.g. owen * * * * * * * * * * * * *
web: http://owenlabs.org/
email: owen_bda4@yahoo.com
* * * * * * * * * * * * * * * * * *


****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <dir.h>
#include <dos.h>
#include <alloc.h>
#include <string>
#include <list>

#define YES (1)
#define NO (0)

#define _f  /* harmless prototoype catcher. */
#define _v  /* like same for vars. */


/****************************************************************************
****************************************************************************/
using namespace std;

typedef list<string> JSTRINGLIST;


/****************************************************************************
****************************************************************************/
void depart(void);

/****************************************************************************
****************************************************************************/
_f void mustopen(FILE **f, char *name, char *mode) {
  if (!(*f=fopen(name,mode))) {
    fprintf(stderr,"couldn't open %s for %s.",name,mode);
    exit(3);
  }
}

_f void nullclose(FILE **file) {
  if (*file) {
    fclose(*file);
    *file=NULL;
  }
}

/* scan off of spaces in s; stop at any non-blank, including \0, \n. Return
1 if end of line -- \n \0, else 0. Mon 05-15-1995 version.*/
_f int scans(char **s) {
  while (**s && (((unsigned char)**s)<=' ') && (**s != '\n') )
  ++(*s);

  return **s=='\n' || **s=='\0';
}

_f char *lastchar(char *s) {
  if (!*s) return s;
  return s+strlen(s)-1;
}

_f void *mustalloc(unsigned size) {      /* clears block to zero. */
  void *p;
  if ((p=calloc(size,1)) != NULL)
  return p;
  fprintf(stderr,"ran out of memory.");
  exit(7);
}

/****************************************************************************
****************************************************************************/


_f char *commaS(char *s) {
  int length=strlen(s);
  char *result=(char*)mustalloc(length*2+10);
  char *d=result;
  int x=length % 3;
  int i, wasdigit=NO;

  for (i=0; i<length; ++i) {

    if (!x--) {
      if (wasdigit)
      *d++ = ',';
      x = 2;
    }

    if(isdigit(*s))
    wasdigit = YES;
      //so I don't get -,123,970

    *d++=*s++;
//    ++d;

  }

  return result;
}

_f char *commas(long d) {
 char abuf[25];
 sprintf(abuf,"%ld",d);
 return
 commaS(abuf);
}

/****************************************************************************
****************************************************************************/
char *iname, *oname;
FILE *ifile, *ofile;

#define VR      '|'
#define PLUS    '+'
#define MINUS   '-'


#define BSIZE (1000)

char abuf[BSIZE];

int asterisks, whereSumAt;

long pennySum;

#define VRAT (80)
int PutSumAt0 = VRAT-1; //0-base it.

int EmitBalance;

/****************************************************************************
****************************************************************************/
/* returns original string. */
_f char *unlineend(char *p) {
  char *e;
  if (e=strchr(p,'\n')) *e='\0';
  return p;
}

/****************************************************************************
****************************************************************************/
_f void badarg(char *who) {
  printf("bad arg: %s\n",who);
  depart();
}

#if 0
//return ","; but terminal error if no comma, nothing after comma.
_f char *commaArg(char *src) {
  char *p=strchr(src,',');

  if ( (!p) || (!p[1]) ) {
    printf("bad comma: %s\n",src);
    depart();
  }

  return ++p;

}
#endif

/****************************************************************************
****************************************************************************/
long readpennies(char *where) {
  long dollars, pennies;

  scans(&where);
  if (sscanf(where,"%d.%02d",&dollars,&pennies)!=2)
  return 0;

  return dollars*100 + pennies;

}

/****************************************************************************
****************************************************************************/
int removeVerticalRule(void) {
  char *p, *e;;
  if (p=strchr(abuf,VR)) {
    *p='\'0';

    e=p-1;

//remove trailing spaces.
    while (
    (e>=abuf) &&
    isspace(*e)
    ) {
      *e = '\0';
      --e;
    }

    return p-abuf;
  }
  return -1;
}

void putpennies(void) {

  strcat(abuf," ");   //at least a single space.


  int w=strlen(abuf);

  while (w<PutSumAt0) {
    abuf[w++]=' ';
    abuf[w]='\0';
  }

  sprintf(abuf+w,"| %5d.%02d",
  pennySum / 100,
  abs
  (pennySum % 100)
  );
}

char *findmoney(int c) {
  char *p=abuf;         //can't be first character.
  while (p = strchr(p+1,c)) {
    if (
    (p[-1] == ' ') &&
    (isdigit(p[1]))
    )
    return p+1;
  }

  return NULL;
}

/****************************************************************************
#if 0
//add a \n if missing. Better be room!
void endofy(char *s) {
  if (!(strchr(s,'\n')))
  strcat(s,"\n");
}
#endif
****************************************************************************/

int process(void) {
  char *p;

  while (fgets(abuf,BSIZE,ifile)) {

    unlineend(abuf);

    whereSumAt=
    removeVerticalRule();

    if (p=strchr(abuf,'=')) {
      pennySum = (readpennies(p+1));
      goto PRINTLINE;
    }


    if (
    asterisks &&
    (!strchr(abuf,'*'))
    )
    goto PRINTLINE;

//then do +/- processing.

    if (p=findmoney(PLUS)) {
      pennySum += readpennies(p);
      goto SHOWSUM;
    }

    if (p=findmoney(MINUS)) {
      pennySum -= readpennies(p);
      goto SHOWSUM;
    }

    goto PRINTLINE;

    SHOWSUM:
    putpennies();


    PRINTLINE:
//    endofy(abuf);
    if (ofile)
    fprintf(ofile,"%s\n",abuf);

  }

  nullclose(&ifile);
  nullclose(&ofile);

  return 0;


}

/****************************************************************************
sumj infile outfile                   `" __DATE__ `"
Takes a file like
          =0
  11/20/10 *{0}paper at staples                -32.58    |   -32.58
  11/20/10 *{0}tech mags @ b&n                 -27.94    |   -60.52
  11/20/10 *{0}tools @ microcenter             -29.30    |   -89.82
and does like that; deleting the stuff after the | and the |, and then summing
as appropriate. The "-" and "+" are magical markers.
-*        Only sum lines with asterisks in them.
-v80      set sum position.
-b        emit the balance at the end!

****************************************************************************/
void depart(void) {

  printf(

"sumj infile outfile                   " __DATE__ "\n"
"Takes a file like\n"
"          =0\n"
"  11/20/10 *{0}paper at staples                -32.58    |   -32.58\n"
"  11/20/10 *{0}tech mags @ b&n                 -27.94    |   -60.52\n"
"  11/20/10 *{0}tools @ microcenter             -29.30    |   -89.82\n"
"and does like that; deleting the stuff after the | and the |, and then summing\n"
"as appropriate. The \"-\" and \"+\" are magical markers.\n"
"-*        Only sum lines with asterisks in them.\n"
"-v80      set sum position.\n"
"-b        emit the balance at the end!\n"

  );
  exit(3);

}


/****************************************************************************
****************************************************************************/
#define QUESTIONS(s) if ((s) && (strchr(s,'?'))) depart()

int main(int argc, char *argv[]) {
  int r, i, opmark='-';        /* do options. */
  for (i=1; i<argc; ++i) {
    QUESTIONS(argv[i]);
    if (argv[i][0]=='/') opmark='/';
/* / forces it to use / subsequently, so u can have files with -. */
    if (argv[i][0]==opmark) {
      switch (argv[i][1]) {
        case 0: break;
        /* make option alone OK, so he can use files with -. */

        case '*':
        asterisks=YES;
        break;

        case 'b':
        EmitBalance=YES;
        break;

        case 'v':
        PutSumAt0 = atoi(argv[i]+2)-1;
        if (PutSumAt0<15)
        depart();
        break;


        default:
        depart();
      }
    }
    else if (!iname)
    iname=argv[i];
    else if (!oname)
    oname=argv[i];
    else depart();
  }

  if (
  (!iname) ||
  (
  (!oname)  && (!EmitBalance)
  )
  )
  depart();

  if (iname)
  mustopen(&ifile,iname,"r");

  if (oname)
  mustopen(&ofile,oname,"w");


  r = process();

  nullclose(&ifile);
  nullclose(&ofile);

  if (EmitBalance)
  printf("Balance is %s.%02d\n",
  commas(pennySum / 100),
  abs(pennySum % 100)
  );

  return r;

}


